package com.wtkj.wrapper;

import com.wtkj.entity.Project;
import com.wtkj.entity.ProjectStage;
import com.wtkj.service.IProjectStageService;
import com.wtkj.vo.ProjectVO;
import org.springblade.core.mp.support.BaseEntityWrapper;
import org.springblade.core.tool.utils.BeanUtil;
import org.springblade.core.tool.utils.SpringUtil;

import java.util.Objects;

/**
 * @author Blizzard
 * @create at 2023-09-16 23:08
 * @describe
 */
public class ProjectWrapper extends BaseEntityWrapper<Project, ProjectVO> {

	private static IProjectStageService stageService;


	public static ProjectWrapper build() {
		stageService = SpringUtil.getBean(IProjectStageService.class);
		return new ProjectWrapper();
	}

	@Override
	public ProjectVO entityVO(Project entity) {
		ProjectVO vo = Objects.requireNonNull(BeanUtil.copy(entity, ProjectVO.class));
		Long currentStage = entity.getCurrentStage();
		if (currentStage != null) {
			ProjectStage byId = stageService.getById(currentStage);
			if (byId != null) {
				vo.setCurrentStageName(byId.getName());
			}
		}
		return vo;
	}
}
